#include <linux/module.h>
#include <linux/kernel.h>
#include <linux/fs.h>
#include <linux/init.h>
#include <linux/delay.h>
#include <linux/uaccess.h>
#include <linux/irq.h>
#include <asm/io.h>
#include <linux/device.h>
static struct class *leddrv_class;

//#if LINUX_VERSION_CODE <= KERNEL_VERSION(4,0,0)
#if 0 //KVER <= "4.0.0" 
static struct class_device * leddrv_class_dev[12];
#else
static struct device *leddrv_class_dev[10];
#endif


volatile unsigned long *gpbcon[12] ;

static int led_drv_open(struct inode *inode, struct file *file)
{

	//int i;
	//for(i= 0; i < sizeof(gpbcon)/sizeof(gpbcon[0]); ++i)
	//	*gpbcon[i] = 0x00000001;
	return 0;
}

static ssize_t led_drv_write(struct file *file, const char __user *buf, size_t count, loff_t * ppos)
{
	char str[12] = {0};
	copy_from_user(str, buf, count); 
//	printk("buf = %s\n", str);
	
	if(!strcmp(str, "led1on")){
		*gpbcon[0] &= 0x11111101; //Ϊoutput
		*gpbcon[0] &= ~(0x00000001);
		*gpbcon[0] |= (0x00000010);
	}
	else if(!strcmp(str, "led1off")){
		*gpbcon[0] &= 0x11111101; //Ϊoutput
		*gpbcon[0] |= 0x00000001;
		*gpbcon[0] |= (0x00000010);
	}
	else if(!strcmp(str, "led2on"))	{
		*gpbcon[1] &= 0x11111101; //Ϊoutput
		*gpbcon[1] |= 0x00000001;
		*gpbcon[1] |= (0x00000010);
	}
	else if(!strcmp(str, "led2off")){
		*gpbcon[1] &= 0x11111101;
		*gpbcon[1] &= ~(0x00000001);
		*gpbcon[1] |= (0x00000010);
	}
	else if(!strcmp(str, "led3on")){
		*gpbcon[2] &= 0x11111101;
		*gpbcon[2] &= ~(0x00000001);
		*gpbcon[2] |= (0x00000010);
	}
	else if(!strcmp(str, "led3off")){
		*gpbcon[2] &= 0x11111101;
		*gpbcon[2] |= 0x00000001;
		*gpbcon[2] |= (0x00000010);
	}
	else if(!strcmp(str, "led4on")){
		*gpbcon[3] &= 0x11111101;
		*gpbcon[3] |= 0x00000001;
		*gpbcon[3] |= (0x00000010);
	}
	else if(!strcmp(str, "led4off")){
		*gpbcon[3] &= 0x11111101;
		*gpbcon[3] &= ~(0x00000001);
		*gpbcon[3] |= (0x00000010);
	}
	else if(!strcmp(str, "led5on")){
		*gpbcon[4] &= 0x11111101;
		*gpbcon[4] &= ~(0x00000001);
		*gpbcon[4] |= (0x00000010);
	}
	else if(!strcmp(str, "led5off")){
		*gpbcon[4] &= 0x11111101;
		*gpbcon[4] |= 0x00000001;
		*gpbcon[4] |= (0x00000010);
	}
	else if(!strcmp(str, "led6on")){
		*gpbcon[5] &= 0x11111101;
		*gpbcon[5] |= 0x00000001;
		*gpbcon[5] |= (0x00000010);
	}
	else if(!strcmp(str, "led6off")){
		*gpbcon[5] &= 0x11111101;
		*gpbcon[5] &= ~(0x00000001);
		*gpbcon[5] |= (0x00000010);
	}
	else if(!strcmp(str, "led7on")){
		*gpbcon[6] &= 0x11111101;
		*gpbcon[6] &= ~(0x00000001);
		*gpbcon[6] |= (0x00000010);
	}
	else if(!strcmp(str, "led7off")){
		*gpbcon[6] &= 0x11111101;
		*gpbcon[6] |= 0x00000001;
		*gpbcon[6] |= (0x00000010);
	}
	else if(!strcmp(str, "led8on")){
		*gpbcon[7] &= 0x11111101;
		*gpbcon[7] |= 0x00000001;
		*gpbcon[7] |= (0x00000010);
	}
	else if(!strcmp(str, "led8off")){
		*gpbcon[7] &= 0x11111101;
		*gpbcon[7] &= ~(0x00000001);
		*gpbcon[7] |= (0x00000010);
	}
	else if(!strcmp(str, "led9on")){
		*gpbcon[8] &= 0x11111101;
		*gpbcon[8] &= ~(0x00000001);
		*gpbcon[8] |= (0x00000010);
	}
	else if(!strcmp(str, "led9off")){
		*gpbcon[8] &= 0x11111101;
		*gpbcon[8] |= 0x00000001;
		*gpbcon[8] |= (0x00000010);
	}
	else if(!strcmp(str, "led10on")){
		*gpbcon[9] &= 0x11111101;
		*gpbcon[9] |= 0x00000001;
		*gpbcon[9] |= (0x00000010);
	}
	else if(!strcmp(str, "led10off")){
		*gpbcon[9] &= 0x11111101;
		*gpbcon[9] &= ~(0x00000001);
		*gpbcon[9] |= (0x00000010);
	}
	else if(!strcmp(str, "led11on")){
		*gpbcon[10] &= 0x11111101;
		*gpbcon[10] &= ~(0x00000001);
		*gpbcon[10] |= (0x00000010);
	}
	else if(!strcmp(str, "led11off")){
		*gpbcon[10] &= 0x11111101;
		*gpbcon[10] |= 0x00000001;
		*gpbcon[10] |= (0x00000010);
	}
	else if(!strcmp(str, "led12on")){
		*gpbcon[11] &= 0x11111101;
		*gpbcon[11] &= ~(0x00000001);
		*gpbcon[11] |= (0x00000010);
	}
	else if(!strcmp(str, "led12off")){
		*gpbcon[11] &= 0x11111101;
		*gpbcon[11] |= 0x00000001;
		*gpbcon[11] |= (0x00000010);
	}
	return 0;
}

static struct file_operations led_drv_fops = {
    .owner  =   THIS_MODULE,    
    .open   =   led_drv_open,     
	.write	=	led_drv_write,	  		 
};


int major, minor;
static int led_drv_init(void)
{

	int i;
	for( i = 0; i < sizeof(gpbcon)/sizeof(gpbcon[0]); ++i){
		 leddrv_class_dev[i] = NULL;
		gpbcon[i] = NULL;
	}
	major = register_chrdev(0, "led_drv", &led_drv_fops); 
	leddrv_class = class_create(THIS_MODULE, "leddrv_drv");

	for( minor = 0; minor < sizeof(gpbcon)/sizeof(gpbcon[0]); ++minor)
		leddrv_class_dev[minor] = device_create(leddrv_class, NULL, MKDEV(major, minor), NULL, "leddrv%d", minor + 1); 

	gpbcon[0]  =  (volatile unsigned long *)ioremap(0xfed0d1b8, 16);    //GPIO14 	   
	gpbcon[1]  =  (volatile unsigned long *)ioremap(0xfed0d028, 16);    //GPIO24
	gpbcon[2]  =  (volatile unsigned long *)ioremap(0xfed0d0b8, 16);    //GPIO18
	gpbcon[3]  =  (volatile unsigned long *)ioremap(0xfed0d0d8, 16);    //GPIO23    
	
	gpbcon[4]  =  (volatile unsigned long *)ioremap(0xfed0d088, 16);    //GPIO17
	gpbcon[5]  =  (volatile unsigned long *)ioremap(0xfed0d0a8, 16);    //GPIO22
	gpbcon[6]  =  (volatile unsigned long *)ioremap(0xfed0d048, 16);    //GPIO16
	
	gpbcon[7]  =  (volatile unsigned long *)ioremap(0xfed0d068, 16);    //GPIO21 
	gpbcon[8]  =  (volatile unsigned long *)ioremap(0xfed0d018, 16);    //GPIO15
	gpbcon[9]  =  (volatile unsigned long *)ioremap(0xfed0d038, 16);    //GPIO20
	gpbcon[10] =  (volatile unsigned long *)ioremap(0xfed0d058, 16);    //GPIO25
	gpbcon[11] =  (volatile unsigned long *)ioremap(0xfed0d098, 16);    //GPIO26

	return 0;
}

static void led_drv_exit(void)
{
	unregister_chrdev(major, "led_drv"); 
	for( minor = 0; minor < sizeof(gpbcon)/sizeof(gpbcon[0]); ++minor)
		device_unregister(leddrv_class_dev[minor]);
	class_destroy(leddrv_class);
	int i;
	for(i= 0; i < sizeof(gpbcon)/sizeof(gpbcon[0]); ++i)
		iounmap(gpbcon[i]);
}


module_init(led_drv_init);
module_exit(led_drv_exit);


MODULE_LICENSE("GPL");
